(**
 The [bin] class, which represents a bin of infinite capacity.

 @version November 2003
 @author Pierre Lemaire
*)

open Item;;

(** [bin] creates a new empty [bin]. *)
class bin:
object

  (** @return the height of this [bin], that is the sum of the heights of the
     [items] it contains. *)
  method get_height: int

  (** @return the number of [items] this [bin] contains. *)
  method get_card: int

  (** @return the list of the [items] this [bin] contains. *)
  method get_items: item list

  (** [add x] adds [item x] on top of this [bin]. *)
  method add: item -> unit

  (** [append y] adds all the [items] of [y] on top of this [bin]. *)
  method append: bin -> unit

  (** @return a string-representation of this [bin]. *)
  method print: string
end

(** [compare_bin x y] returns [0] if both [x] and [y] are of equal height, a
    negative integer if [x] is higher than [y], and a positive integer
    otherwise. *)
val compare_bin: bin -> bin -> int
