(**
 An [instance] which can explore all the permutation of its [item] set.

 @version February 2004
 @author Pierre Lemaire
*)

open Item;;
open Bin;;
open Instance;;


(** [instance_perm inst] creates a new [instance_perm] from [inst]. *)
class instance_perm:
  instance -> 
object
  val m: int
  val mutable value: int
  val mutable n: int
  val mutable hmax: int
  val mutable smax: int
  val mutable items: item list

  method get_n: unit -> int
  method get_m: unit -> int
  method get_hmax: unit -> int
  method get_smax: unit -> int
  method get_hmin: unit -> int
  method get_smin: unit -> int
  method get_volume: unit -> int
  method get_bound: unit -> int
  method add: item -> unit
  method get_items: unit -> item list
  method sort_items: unit -> unit
  method print: unit -> string
  (** sets the [instance] to generate the next permutation of its [items].
      @return [false] if there is none. *)
  method next: unit -> bool
end
