open Constants;;
type options_type = 
{ mutable display: int;
  mutable trace: int;
  mutable ftrace: out_channel;

};;

let options =
{ display  = cDISPLAY_SIMPLE;
  trace    = cTRACE_NONE;
  ftrace   = stderr;
};;

let set_display x = match (x) with
 | "simple" -> options.display <- cDISPLAY_SIMPLE
 | "normal" -> options.display <- cDISPLAY_NORMAL
 | "pretty" -> options.display <- cDISPLAY_PRETTY
 | _  	    -> options.display <- cDISPLAY_SIMPLE
;;

let set_trace x = match (x) with
 | "none" -> options.trace <- cTRACE_NONE
 | "some" -> options.trace <- cTRACE_SOME
 | "most" -> options.trace <- cTRACE_MOST
 | "all"  -> options.trace <- cTRACE_ALL
 | _  	  -> options.trace <- cTRACE_NONE
;;

let set_ftrace x =
  options.ftrace <- try open_out x
    with Sys_error msg ->
      Printf.fprintf stderr "warning: %s (stderr used for printing trace)\n" msg;
      stderr
;;

let tracer x s =
  if (x < options.trace) then begin
    output_string options.ftrace s;
    flush options.ftrace
  end
;;
