(** 
  To keep general options'values...

 @version November 2003 - December 2003
 @author Pierre Lemaire
*)

type options_type = 
{ mutable display: int;  (** The type of display (DISPLAY_SIMPLE (default), DISPLAY_NORMAL, DISPLAY_PRETTY). *)
  mutable trace: int;    (** The level of trace  (TRACE_NONE (default), TRACE_SOME, TRACE_MOST, TRACE_ALL). *)
  mutable ftrace: out_channel; (** Where the trace is printed (default: stderr). *)


};;

(** The variable that keeps the options' values. *)
val options: options_type

(** Set the value of [options.display] (see above). *)
val set_display: string -> unit

(** Set the value of [options.trace] (see above). *)
val set_trace:   string -> unit

(** Set the value of [options.ftrace] (see above). *)
val set_ftrace:  string -> unit

(** [tracer x msg] prints [msg] on [options.ftrace] if [x] is less than [options.trace]. *)
val tracer: int -> string -> unit
