open Constants;;
(** A [solution] builds according to the decreasing next-bin (DNB) rule.

 @version April 2004
 @author Pierre Lemaire
*)

open Options;;
open Item;;
open Bin;;
open Instance;;
open Solution;;
open Solution_nb;;

class solution_dnb (m:int) =
object (self)
  inherit solution_nb m as super

  (** re-order the [items] of the [instance] by decreasing height and then 
      pack them according to the NB rule (note that the order of the [items]
      in the [instance] is thus changed). *)
  method build (inst:instance) =
    set_compare_item "dh";
    inst#sort_items();
    super#build inst;
end
