open Constants;;
(** A [solution] builds according to the decreasing OP (DOP) rule.

 @version April 2004
 @author Pierre Lemaire
*)

open Options;;
open Item;;
open Bin;;
open Instance;;
open Solution;;
open Solution_op;;

class solution_dop (m:int) =
object (self)
  inherit solution_op m as super

  (** re-order the [items] of the [instance] by decreasing size and then 
      pack them according to the OP rule (note that the order of the [items]
      in the [instance] is thus changed). *)
  method build (inst:instance) =
    set_compare_item "ds";
    inst#sort_items();
    super#build inst;
end
