open Constants;;
(** A [solution] builds according to the Next-Bin (NB) rule.

 @version April 2004
 @author Pierre Lemaire
 *)

open Options;;
open Item;;
open Bin;;
open Instance;;
open Solution;;

class solution_nb (m:int) =
object (self)
  inherit solution m as super

  (** pack the [items] of the given [instance] according to the NB rule, in the
      order they are in the [instance]. *)
  method build (inst:instance) =
    let items = Array.of_list (inst#get_items())
    and n = inst#get_n()
    and m = inst#get_m()
    and i = ref 0
    in tracer 0 "Performing NB...\n";
       if (m != Array.length bins) then raise(Incompatible_solution);
       for j=0 to (n-1) do
         (* adds item j to the sj next bins *)
         for k=1 to items.(j)#get_size do
           super#add items.(j) !i;
           i := (!i + 1) mod m;
         done;
       done;
end
