open Constants;;
(**
 Provides statistics on multibin instances.
 See help for details.

 @version April 2004
 @author Pierre Lemaire
*)

(* ========================================================================= *)
(* ========================================================================= *)

open Options;;
open Misc;;
open Item;;
open Instance;;
open Printf;;

let stats() = try
  let inputname = ref ""
  in let arglist = []
  in
    Arg.parse arglist (set_id inputname) "";
    let inst = read_instance !inputname
    in printf "%d ; %d ; %d ; %d ; %d ; %d "
              (inst#get_n())    (inst#get_m())
              (inst#get_hmax()) (inst#get_hmin())
              (inst#get_smax()) (inst#get_smin())
with 
  | Failure msg -> fprintf stderr "%s" msg; exit 1;
(*  | _           -> fprintf stderr "unexpected error (BUG)"; exit 99;*)
;;

(* ========================================================================= *)
if !Sys.interactive
then
  ()
else begin
  stats()
end;;

(* ========================================================================= *)
(* ========================================================================= *)
